#!/usr/bin/perl -w
use Test; 
BEGIN { plan tests => 14 }
BEGIN { unshift @INC, "../blib/lib" }
use POWER::lib;

$out    = Cat("/dev/null");
ok($out, '',                "'' from /dev/null");

@out    = Cat("/dev/null");
ok(@out, 0,                 "() from /dev/null");

$TempFile = "tmp.dat";

@expect = ("line1\n", "line2\n", "line3");
$expect = join "", @expect;
open TMP, ">$TempFile" or die $@; print TMP $expect; close TMP;
$out    = Cat($TempFile);
ok($out, $expect,           "3 lines without CR, as scalar");

@out    = Cat($TempFile);
ok(@out, @expect,           "3 lines without CR, as list");

ok(join("",@out), $expect,  "3 lines without CR, as joined list");

@expect = ("line1\n", "line2\n", "line3\n");
$expect = join "", @expect;
open TMP, ">tmp.dat" or die $@; print TMP $expect; close TMP;
$out    = Cat($TempFile);
ok($out, $expect,           "3 lines with CR, as scalar");

@out    = Cat($TempFile);
ok(@out, @expect,           "3 lines with CR, as list");

ok(join("",@out), $expect,  "3 lines with CR, as joined list");

{ local $/;
@out    = Cat($TempFile);
ok(@out, 1,                 "3 lines with CR, as list, \$\/ undefined");

$out    = Cat($TempFile);
ok($out, $expect,           "3 lines with CR, as scalar, \$\/ undefined");
} # local $/

unlink $TempFile;

$out    = Cat($TempFile);
ok($out, undef,             "error, as scalar");

@out    = Cat($TempFile);
ok(@out, 0,                 "error, as list");

ok(0+$!, 2,                 "error code");

$out    = Cat(">$TempFile");
ok($out, undef,             "error [trying to create file]");

